# VideoStabilizationTechniques
Survey of iterative 2D video stabilization techniques for EE 367 final project 

**Acknowledgements and references**  

Parts of the stabilization pipeline referenced code from the following open-source repositories.  
Mean filtering: [https://github.com/spmallick/learnopencv/tree/master/VideoStabilization]
L1 Optimal Camera Path: [https://github.com/ishank-juneja/L1-optimal-paths-Stabilization?tab=readme-ov-file]
Test video: [https://www.youtube.com/watch?v=2S_U1pnLE-M]

**Dataset**   

The DeepStab dataset can be accessed here: [https://github.com/cxjyxxme/deep-online-video-stabilization-deploy]

**Setting up environment**  
These instructions assume user has conda installed. Run the following commands to enter the conda environment. 
```
conda env create -f environment.yml
conda activate vidstab 
```
To deactivate run the following. 
```conda deactivate``` 

**Running Filtering parameter tuning script**   
This script will reproduce the filtered paths diagram as seen in the project report. It will also print metrics for each filter test. 

**Running Final Paths script** 
This script will reproduce the final filtered paths and the L1 optimized path diagrams as seen in the project report and poster. It will also output the final video frames and mp4 files. Evaluated on YouTube test video and video 2 from DeepStab dataset. 
```python3 ideal_paths.py```
The final videos are saved in the relative path './output/scenery/' and './output/scenery/' for each video evaluated.  
The trajectory plots will show up as 'filtering_comparison_scenery.png','filtering_comparison_skate.png','l1_optimization_scenery.png', 'l1_optimization_skate.png'

**Running L1 Optimization weight tuning script**   
This script will reproduce the L1 camera trajectories of varying weights as seen in the project report. Evaluated on YouTube test video.
```python3 optimization_tuning.py```
The trajectory plot will show up as 'l1_opt_comparison.png' 

**Running metrics script**  

**Running X-T slice script**  
This script will reproduce the X-T slices of filtering methods and L1 stabilization as seen in the project report. Evaluated on YouTube test video.
```python3 x_t_slices_comparison.py```
X-T slices will show up in the relative path: './output/xtslices/'



