import cv2 
import numpy as np 

def calculate_cropped_pixel_ratio(frames, N):

    crop_ratios = []
    total_pixels = frames[0].shape[0] * frames[0].shape[1]

    for i in range(N):
        # Convert the frame to grayscale
        gray_frame = cv2.cvtColor(frames[i], cv2.COLOR_BGR2GRAY)
        
        # Threshold the image to get binary image of black pixels 
        _, binary_frame = cv2.threshold(gray_frame, 1, 255, cv2.THRESH_BINARY)

        black_pixels = np.sum(binary_frame == 0) # pixels that retain video data
        ratio = (total_pixels - black_pixels) / total_pixels
        
        crop_ratios.append(ratio)
    
    average_ratio = np.mean(crop_ratios)
    
    print(f"Crop Ratio: {average_ratio}")

    return average_ratio

def get_crop_ratio(original_frame, stabilized_frame, total_pixels): 
    # Convert the frame to grayscale
    gray_frame = cv2.cvtColor(stabilized_frame, cv2.COLOR_BGR2GRAY)
    
    # Threshold the image to get binary image of black pixels 
    _, binary_frame = cv2.threshold(gray_frame, 1, 255, cv2.THRESH_BINARY)

    black_pixels = np.sum(binary_frame == 0) # pixels that retain video data
    ratio = ((total_pixels - black_pixels) / total_pixels) * 100

    return ratio