import numpy as np

def calculate_distortion(homography_matrix):
    # Extract scaling components from the homography matrix
    scaling_x = np.sqrt(homography_matrix[0, 0] * homography_matrix[0, 0] + homography_matrix[1, 0] * homography_matrix[1, 0])
    scaling_y = np.sqrt(homography_matrix[0, 1] * homography_matrix[0, 1] + homography_matrix[1, 1] * homography_matrix[1, 1])

    # Calculate the anisotropic scaling
    distortion = max(scaling_x, scaling_y) / min(scaling_x, scaling_y)

    return distortion
