import cv2
import numpy as np
from skimage.metrics import peak_signal_noise_ratio as compute_psnr

def compute_global_psnr(original_frames, stabilized_frames, N):

    psnr_values = []
    
    for i in range(N):
        frame1 = original_frames[i]
        frame2 = stabilized_frames[i] + 0.001 # prevent divide by zero if similar frames

        psnr = compute_psnr(frame1, frame2)
        psnr_values.append(psnr)

    average_psnr = np.mean(psnr_values)
    
    print(f"GTF PSNR: {average_psnr} dB")

    return average_psnr