import cv2
import numpy as np
from skimage.metrics import peak_signal_noise_ratio as compute_psnr

def compute_interframe_psnr(frames, N):

    psnr_values = []

    for i in range(N-1):
        frame1 = frames[i]
        frame2 = frames[i+1] + 0.001 # prevent divide by zero if similar frames
        psnr = compute_psnr(frame1, frame2)
        psnr_values.append(psnr)

    average_psnr = np.mean(psnr_values)
    
    print(f"ITF PSNR: {average_psnr} dB")

    return average_psnr

def get_interframe_psnr(frames, N):

    psnr_values = []

    for i in range(N-1):
        frame1 = frames[i]
        frame2 = frames[i+1] + 0.001 # prevent divide by zero if similar frames
        psnr = compute_psnr(frame1, frame2)
        psnr_values.append(psnr)

    average_psnr = np.mean(psnr_values)
    
    print(f"ITF PSNR: {average_psnr} dB")

    return average_psnr